/**
   Classe pour représenter une solution
   
   Chaine de bits auquel est ajoutée la valeur de la qualité (fitness)
*/
public class Solution {
    // bit string solution
    public boolean [] bitString;

    // quality of the solution
    int fitness;

    /***********************************
     * Constructor
     ***********************************/
    public Solution() {
	this.bitString = null;
	this.fitness = 0;
    }

    public Solution(Solution _s) {
	if (_s.bitString != null) {
	    this.bitString = new boolean[_s.bitString.length];
	    for(int i = 0; i < this.bitString.length; i++)
		this.bitString[i] = _s.bitString[i];
	} else {
	    this.bitString = null;
	}

	this.fitness = _s.fitness();
    }

    public Solution clone() {
	Solution solution = new Solution(this);
	return solution;
    }

    /**
     * set the fitness
     */
    public void fitness(int _fit) {
	this.fitness = _fit;
    }
    
    /**
     * get the fitness
     */
    public int fitness() { 
	return this.fitness; 
    }


    public int size() {
	if (this.bitString == null) {
	    return 0 ;
	} else {
	    return bitString.length;
	}
    }

    /**
     * print the solution
     */
    public String toString() {
	String s = this.fitness() + " " ;

	if (this.bitString == null) {
	    s += "0" ;
	} else {
	    s += this.bitString.length + " ";
	
	    for(int i = 0; i < this.bitString.length; i++)
		if (this.bitString[i])
		    s += "1" ;
		else
		    s += "0" ;
	}

	return s;
    }
}

